//loop så att spelet kan fortsätta uppdatera
//när allt är klart laddat körs den här
window.onload = function onload() {
    canvas = document.getElementById('gameCanvas');
    ctx = canvas.getContext('2d');

    spawnSnake();
    placeFruit();

    if (levelOne) {
        for (let i = 0; i < 10; i++) {
            smallObstacle();
        }
    }
    if (levelTwo) {
        for (let i = 0; i < 5; i++) {
            bigObstacle();
        }
    }

//behövs ingen level 3 eftersom den uppdateras automatiskt

//level 4 görs i generateFoods funktionen i update funktionen

    if (levelNormal) {
        normalMode()
    }

    document.addEventListener("keydown", keyPush); //lyssnar efter knapp tryck 

    clearInterval(gameInterval); 
    gameInterval = setInterval(update, 1000/updateSpeed); //game 
}

// whole as fucking game loop <3
function update() {
    // om spel pausat körs inte funktionen
    if (gamePaused) {
        return;
    }

    // Clear the canvas and redraw the background
    ctx.fillStyle = "black";
    ctx.fillRect(0, 0, gridSize, gridSize);

    // Draw the grid in white
    ctx.strokeStyle = "white";
    ctx.lineWidth = 1;
    for (let i = 0; i <= gridSize; i += tileSize) {
        ctx.beginPath();
        ctx.moveTo(i, 0); // Vertical lines
        ctx.lineTo(i, gridSize);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(0, i); // Horizontal lines
        ctx.lineTo(gridSize, i);
        ctx.stroke();
    }

    // Draw small obstacles
    ctx.fillStyle = "gray";
    if (levelOne) {
        for (let i = 0; i < smallObstacleArray.length; i++) {
            const [smallObstacleX, smallObstacleY] = smallObstacleArray[i];
            //blocks
            ctx.fillRect(smallObstacleX, smallObstacleY, tileSize, tileSize);
            //borders
            ctx.strokeRect(smallObstacleX, smallObstacleY, tileSize, tileSize);
        }
    }

    // Draw big obstacles
    ctx.fillStyle = "darkgray";
    if (levelTwo) {
        for (let i = 0; i < bigObstacleArray.length; i++) {
            const [bigObstacleX, bigObstacleY] = bigObstacleArray[i];
            //blocks
            ctx.fillRect(bigObstacleX, bigObstacleY, tileSize, tileSize);
            ctx.fillRect(bigObstacleX + tileSize, bigObstacleY, tileSize, tileSize);
            ctx.fillRect(bigObstacleX - tileSize, bigObstacleY, tileSize, tileSize);
            ctx.fillRect(bigObstacleX, bigObstacleY + tileSize, tileSize, tileSize);
            ctx.fillRect(bigObstacleX, bigObstacleY - tileSize, tileSize, tileSize);
            //borders
            ctx.strokeRect(bigObstacleX, bigObstacleY, tileSize, tileSize);
            ctx.strokeRect(bigObstacleX + tileSize, bigObstacleY, tileSize, tileSize);
            ctx.strokeRect(bigObstacleX - tileSize, bigObstacleY, tileSize, tileSize);
            ctx.strokeRect(bigObstacleX, bigObstacleY + tileSize, tileSize, tileSize);
            ctx.strokeRect(bigObstacleX, bigObstacleY - tileSize, tileSize, tileSize);
        }
    }

    // Update the head's position first
    if (velocityX !== 0 || velocityY !== 0) {
        snakeX += velocityX * tileSize;
        snakeY += velocityY * tileSize;
    }
    // same but second snake
    if (levelThree) {
        if (velocityX2 !== 0 || velocityY2 !== 0) {
            secondSnakeX += velocityX2 * tileSize;
            secondSnakeY += velocityY2 * tileSize;
        }
    }

    // Check for collisions with walls, itself, or obstacles
    if (
                // first if they crash into border of canvas
        snakeX < 0 ||
        snakeX >= gridSize ||
        snakeY < 0 ||
        snakeY >= gridSize ||
                // Check if the snake collides with itself
        snakeBody.slice(1).some(e => e[0] === snakeX && e[1] === snakeY) ||
                // (LEVEL ONE) Check if the snake collides with small obstacles
        (levelOne && smallObstacleArray.some(obstacle => obstacle[0] === snakeX && obstacle[1] === snakeY)) ||
                // (LEVEL TWO) Check if the snake collides with big obstacles
        ((levelTwo) &&
            (bigObstacleArray.some(obstacle =>
                (obstacle[0] === snakeX && obstacle[1] === snakeY) ||
                (obstacle[0] === snakeX + tileSize && obstacle[1] === snakeY) ||
                (obstacle[0] === snakeX - tileSize && obstacle[1] === snakeY) ||
                (obstacle[0] === snakeX && obstacle[1] === snakeY + tileSize) ||
                (obstacle[0] === snakeX && obstacle[1] === snakeY - tileSize)
            )
        )) 
                // (LEVEL THREE) if crash into other snake
        || (levelThree && secondSnakeBody.some(e => e[0] === snakeX && e[1] === snakeY))
    ) {
        // Game over logic
        updateHighscores();
        points = 0;
        pointDiv.innerHTML = "Score:" + points;
        updateSpeed = 6;
        speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;
        clearInterval(gameInterval);
        gameInterval = setInterval(update, 1000 / updateSpeed);
        spawnSnake();
        placeFruit();
        return;
    }
        
    // crash check for second snake
    if (
        levelThree &&
        (
                //border crash    
        secondSnakeX < 0 || secondSnakeX >= gridSize || secondSnakeY < 0 || secondSnakeY >= gridSize ||
                // crash in i sig sjökv
        secondSnakeBody.slice(1).some(e => e[0] === secondSnakeX && e[1] === secondSnakeY) ||
                //crash i andra ormen
        snakeBody.some(e => e[0] === secondSnakeX && e[1] === secondSnakeY))

        // No logik för obstacle krashing (inte samma level)
    ) {
        // Game over logic
        updateHighscores();
        points = 0;
        pointDiv.innerHTML = "Score:" + points;
        updateSpeed = 6;
        speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;
        clearInterval(gameInterval);
        gameInterval = setInterval(update, 1000 / updateSpeed);
        spawnSnake();
        placeFruit();
        return;
    }

    // Check if the snake eats the fruit när inte level 4 eftersom den har flera frukter
    if ((snakeX === appleX && snakeY === appleY) && !levelFour) {
        placeFruit();
        snakeBody.push([snakeBody[snakeBody.length - 1][0], snakeBody[snakeBody.length - 1][1]]); // Add a new segment
        points += 1;
        pointDiv.innerHTML = "Score:" + points;

        if (points % 5 === 0 && points !== 0 && updateSpeed < 12) {
            updateSpeed += 1.5;
        }

        speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

        // Generate small obstacles
        // Clear the array before generating new obstacles
        smallObstacleArray = [];
        for (let i = 0; i < 10; i++) {
            smallObstacle();
        }

        // Update the game interval speed if possible
        clearInterval(gameInterval);
        gameInterval = setInterval(update, 1000 / updateSpeed);
    }

    // Check if the second snake eats the fruit
    if (levelThree && secondSnakeX === appleX && secondSnakeY === appleY) {
        placeFruit();
        secondSnakeBody.push([secondSnakeBody[secondSnakeBody.length - 1][0], secondSnakeBody[secondSnakeBody.length - 1][1]]); // Add a new segment
        points += 1;
        pointDiv.innerHTML = "Score:" + points;

        if (points % 5 === 0 && points !== 0 && updateSpeed < 12) {
            updateSpeed += 1.5;
        }
        speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

        // Update the game interval speed
        clearInterval(gameInterval);
        gameInterval = setInterval(update, 1000 / updateSpeed);
    }


    // Check if the snake eats the fruit in levelFour
    if (levelFour) {
        for (let i = 0; i < foodArray.length; i++) {
            const [foodX, foodY] = foodArray[i];
            if (snakeX === foodX && snakeY === foodY) {
                points += 1;
                pointDiv.innerHTML = "Score:" + points;

                if (points % 5 === 0 && points !== 0 && updateSpeed < 12) {
                    updateSpeed += 1.5;
                }
        
                speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;
    
                snakeBody.push([snakeBody[snakeBody.length - 1][0], snakeBody[snakeBody.length - 1][1]]); //new segment for snake
    
                // Regenerate all food positions
                generateFoods();
                break;
            }
        }
    }

    // Draw the fruit / fruits
    ctx.fillStyle = "red";
    if (!levelFour) {
    ctx.fillRect(appleX, appleY, tileSize, tileSize);
    ctx.strokeRect(appleX, appleY, tileSize, tileSize);
    }
    if (levelFour) {
        for (let i = 0; i < foodArray.length; i++) {
            const [foodX, foodY] = foodArray[i];
            ctx.fillRect(foodX, foodY, tileSize, tileSize);
            ctx.strokeRect(foodX, foodY, tileSize, tileSize);
        }
    }

    // Update the snake's body to follow the head
    if (velocityX !== 0 || velocityY !== 0) {
        for (let i = snakeBody.length - 1; i > 0; i--) {
            snakeBody[i] = [...snakeBody[i - 1]]; // Each segment follows the previous one
        }

        if (snakeBody.length > 0) {
            snakeBody[0] = [snakeX, snakeY]; // The first body segment follows the head
        }
    }
    // same but second snake
    if (levelThree && (velocityX2 !== 0 || velocityY2 !== 0)) {
        for (let i = secondSnakeBody.length - 1; i > 0; i--) {
            secondSnakeBody[i] = [...secondSnakeBody[i - 1]];
        }
        secondSnakeBody[0] = [secondSnakeX, secondSnakeY];
    }

    // Draw the snake
    for (let i = 0; i < snakeBody.length; i++) {
        if (i === 0) {
            ctx.fillStyle = "green"; // Head
        } else {
            ctx.fillStyle = "lightgreen"; // Body
        }
        ctx.fillRect(snakeBody[i][0], snakeBody[i][1], tileSize, tileSize);
        ctx.strokeRect(snakeBody[i][0], snakeBody[i][1], tileSize, tileSize);
    }
    // Draw the second snake for levelThree
    if (levelThree) {
        for (let i = 0; i < secondSnakeBody.length; i++) {
            ctx.fillStyle = i === 0 ? "blue" : "lightblue"; // om den ritar huvudet (i=0) ritar den blå annars ljusblå
            ctx.fillRect(secondSnakeBody[i][0], secondSnakeBody[i][1], tileSize, tileSize);
            ctx.strokeRect(secondSnakeBody[i][0], secondSnakeBody[i][1], tileSize, tileSize);
        }
    }
}

function placeFruit() {
    // apple X och Y = random nummer mellan(0-1) * 20 och gör det till ett heltal * 25 vilket ger ett värde på en random ruta
    // alltså en random ruta i hela griden
    appleX = Math.floor(Math.random() * tileAmount) * tileSize;
    appleY = Math.floor(Math.random() * tileAmount) * tileSize;
    // logik för om frukten hamnar i en otilåten ruta
    if (appleX == snakeX && appleY == snakeY || appleX == secondSnakeX && appleY == secondSnakeY // hamnar i ormarnas kropp
        || smallObstacleArray.some(obstacle => obstacle[0] === appleX && obstacle[1] === appleY)
        || snakeBody.some(segment => segment[0] === appleX && segment[1] === appleY)
        || bigObstacleArray.some(obstacle =>
            (obstacle[0] === appleX && obstacle[1] === appleY) || // Center block
            (obstacle[0] === appleX + tileSize && obstacle[1] === appleY) || // Right block
            (obstacle[0] === appleX - tileSize && obstacle[1] === appleY) || // Left block
            (obstacle[0] === appleX && obstacle[1] === appleY + tileSize) || // Bottom block
            (obstacle[0] === appleX && obstacle[1] === appleY - tileSize)    // Top block
        )
    ){  
        placeFruit();
    }
}

function spawnSnake() {
    // Snake random position within the grid
    snakeX = Math.floor(Math.random() * tileAmount) * tileSize;
    // Ensure the body of the snake does not spawn on the edges of the grid
    if (snakeX === 0 || snakeX === tileSize || snakeX === tileSize * 2) {
        spawnSnake();
    }
    snakeY = Math.floor(Math.random() * tileAmount) * tileSize;

    // Snake body with three segments
    snakeBody = [
        [snakeX, snakeY], // Head
        [snakeX - tileSize, snakeY], // First segment
        [snakeX - 2 * tileSize, snakeY] // Second segment
    ];

    // Reset velocity
    velocityX = 0;
    velocityY = 0;

    // Reset direction flags
    goingDown = false;
    goingUp = false;
    goingLeft = false;
    goingRight = false;

    if (levelThree) {
        // SAMMMA SAKER HÄNDER FÖR ANDRA ORMEN
        secondSnakeX = Math.floor(Math.random() * tileAmount) * tileSize;
        // Ensure the second snake does not spawn on the edges of the grid
        if (secondSnakeX === 0 || secondSnakeX === tileSize || secondSnakeX === tileSize * 2) {
            spawnSnake();
        }
        secondSnakeY = Math.floor(Math.random() * tileAmount) * tileSize;
        secondSnakeBody = [
            [secondSnakeX, secondSnakeY],
            [secondSnakeX - tileSize, secondSnakeY],
            [secondSnakeX - 2 * tileSize, secondSnakeY]
        ];
        velocityX2 = 0;
        velocityY2 = 0;

        // Reset direction flags for the second snake
        goingDown2 = false;
        goingUp2 = false;
        goingLeft2 = false;
        goingRight2 = false;
    }

    // Reset game variables
    updateSpeed = 6;
    points = 0;
    pointDiv.innerHTML = "Score:" + points;
    speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

    // Ensure the snake does not overlap with the fruit or obstacles
    if (
        snakeBody.some(segment => segment[0] === appleX && segment[1] === appleY) || // Overlaps with fruit
        smallObstacleArray.some(obstacle => snakeBody.some(segment => segment[0] === obstacle[0] && segment[1] === obstacle[1])) || // Overlaps with small obstacles
        bigObstacleArray.some(obstacle => 
            snakeBody.some(segment => 
                (segment[0] === obstacle[0] && segment[1] === obstacle[1]) || // Center block
                (segment[0] === obstacle[0] + tileSize && segment[1] === obstacle[1]) || // Right block
                (segment[0] === obstacle[0] - tileSize && segment[1] === obstacle[1]) || // Left block
                (segment[0] === obstacle[0] && segment[1] === obstacle[1] + tileSize) || // Bottom block
                (segment[0] === obstacle[0] && segment[1] === obstacle[1] - tileSize)    // Top block
            )
        )
    ) {
        spawnSnake(); // Try again if the snake overlaps with obstacles or the fruit
        return;
    }

    // Ensure the snake does not spawn outside the grid
    if (snakeX - 2 * tileSize < 0) {
        spawnSnake();
        return;
    }
}

//funktioner för alla knapptrycker
function keyPush(e) {
    // Handle all levels except levelThree
    if (!levelThree) {
        // Movement for the single snake (both WASD and Arrow keys)
        if ((e.code === "ArrowLeft" || e.code === "KeyA") && !goingRight) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = -1;
                velocityY = 0;

                goingLeft = true;
                goingRight = false;
                goingUp = false;
                goingDown = false;
            }
        }
        if ((e.code === "ArrowUp" || e.code === "KeyW") && !goingDown) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = 0;
                velocityY = -1;

                goingUp = true;
                goingDown = false;
                goingLeft = false;
                goingRight = false;
            }
        }
        if ((e.code === "ArrowRight" || e.code === "KeyD") && !goingLeft) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = 1;
                velocityY = 0;

                goingRight = true;
                goingLeft = false;
                goingUp = false;
                goingDown = false;
            }
        }
        if ((e.code === "ArrowDown" || e.code === "KeyS") && !goingUp) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = 0;
                velocityY = 1;

                goingDown = true;
                goingUp = false;
                goingLeft = false;
                goingRight = false;
            }
        }
    }

    // Handle levelThree (two snakes)
    if (levelThree) {
        // First snake movement (Arrow keys)
        if (e.code === "ArrowLeft" && !goingRight) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = -1;
                velocityY = 0;

                goingLeft = true;
                goingRight = false;
                goingUp = false;
                goingDown = false;
            }
        }
        if (e.code === "ArrowUp" && !goingDown) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = 0;
                velocityY = -1;

                goingUp = true;
                goingDown = false;
                goingLeft = false;
                goingRight = false;
            }
        }
        if (e.code === "ArrowRight" && !goingLeft) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = 1;
                velocityY = 0;

                goingRight = true;
                goingLeft = false;
                goingUp = false;
                goingDown = false;
            }
        }
        if (e.code === "ArrowDown" && !goingUp) {
            if (snakeX % tileSize === 0 && snakeY % tileSize === 0) {
                velocityX = 0;
                velocityY = 1;

                goingDown = true;
                goingUp = false;
                goingLeft = false;
                goingRight = false;
            }
        }

        // Second snake movement (WASD keys)
        if (e.code === "KeyA" && !goingRight2) {
            if (secondSnakeX % tileSize === 0 && secondSnakeY % tileSize === 0) {
                velocityX2 = -1;
                velocityY2 = 0;

                goingLeft2 = true;
                goingRight2 = false;
                goingUp2 = false;
                goingDown2 = false;
            }
        }
        if (e.code === "KeyW" && !goingDown2) {
            if (secondSnakeX % tileSize === 0 && secondSnakeY % tileSize === 0) {
                velocityX2 = 0;
                velocityY2 = -1;

                goingUp2 = true;
                goingDown2 = false;
                goingLeft2 = false;
                goingRight2 = false;
            }
        }
        if (e.code === "KeyD" && !goingLeft2) {
            if (secondSnakeX % tileSize === 0 && secondSnakeY % tileSize === 0) {
                velocityX2 = 1;
                velocityY2 = 0;

                goingRight2 = true;
                goingLeft2 = false;
                goingUp2 = false;
                goingDown2 = false;
            }
        }
        if (e.code === "KeyS" && !goingUp2) {
            if (secondSnakeX % tileSize === 0 && secondSnakeY % tileSize === 0) {
                velocityX2 = 0;
                velocityY2 = 1;

                goingDown2 = true;
                goingUp2 = false;
                goingLeft2 = false;
                goingRight2 = false;
            }
        }
    }

    // Pause or resume the game (Space key)
    if (e.code === "Space") {
        if (gamePaused) {
            // Resume the game
            gamePaused = false;
            gameInterval = setInterval(update, 1000 / updateSpeed); // Restart game loop
            pauseButton.innerHTML = "Pause";
        } else {
            // Pause the game
            gamePaused = true;
            clearInterval(gameInterval); // Stop game loop
            pauseButton.innerHTML = "Resume";
        }
    }
}

//pause button --- samma logik som spacebar
pauseButton.onclick = function() {
    if (gamePaused) {
        gamePaused = false;
        gameInterval = setInterval(update, 1000 / updateSpeed); // Restarta game loop
        pauseButton.innerHTML = "Pause";
    } else {
        gamePaused = true;
        clearInterval(gameInterval); // Stoppa game loop
        pauseButton.innerHTML = "Resume";
    }
}

//level buttons
level1.onclick = function() {
    clearInterval(gameInterval);
    gameInterval = setInterval(update, 1000 / 6);
    spawnSnake();
    placeFruit();

    points = 0;
    pointDiv.innerHTML = "Score:" + points;
    updateSpeed = 6;
    speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

    levelOne = true;
    levelTwo = false;
    levelThree = false;
    levelFour = false;
    levelNormal = false;

    // Generate small obstacles
    smallObstacleArray = []; // Clear array
    for (let i = 0; i < 10; i++) {
        smallObstacle();
    }
}

level2.onclick = function() {
    clearInterval(gameInterval);
    gameInterval = setInterval(update, 1000 / 6);
    spawnSnake();
    placeFruit();

    points = 0;
    pointDiv.innerHTML = "Score:" + points;
    updateSpeed = 6;
    speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

    levelOne = false;
    levelTwo = true;
    levelThree = false;
    levelFour = false;
    levelNormal = false;

    // Generate big obstacles
    bigObstacleArray = []; // Clear array
    for (let i = 0; i < 10; i++) {
        bigObstacle();
    }

}

level3.onclick = function() {
    clearInterval(gameInterval);
    gameInterval = setInterval(update, 1000 / 6);

    points = 0;
    pointDiv.innerHTML = "Score:" + points;
    updateSpeed = 6;
    speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

    levelOne = false;
    levelTwo = false;
    levelThree = true;
    levelFour = false;
    levelNormal = false;

    spawnSnake();
    placeFruit();
}

level4.onclick = function() {
    clearInterval(gameInterval);
    gameInterval = setInterval(update, 1000 / 6);

    points = 0;
    pointDiv.innerHTML = "Score:" + points;
    updateSpeed = 6;
    speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

    levelOne = false;
    levelTwo = false;
    levelThree = false;
    levelFour = true;
    levelNormal = false;

    spawnSnake();
    generateFoods();
}

reset.onclick = function() {
    clearInterval(gameInterval);
    gameInterval = setInterval(update, 1000 / 6);
    spawnSnake();
    placeFruit();

    points = 0;
    pointDiv.innerHTML = "Score:" + points;
    updateSpeed = 6;
    speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;

    levelOne = false;
    levelTwo = false;
    levelThree = false;
    levelFour = false;
    levelNormal = true;
}

//level 1

function smallObstacle() {
    let smallObstacleX = Math.floor(Math.random() * tileAmount) * tileSize;
    let smallObstacleY = Math.floor(Math.random() * tileAmount) * tileSize;

    // obstacle no sapwn in the frut och orm <3
    if (
        (smallObstacleX === snakeX && smallObstacleY === snakeY) ||
        (smallObstacleX === appleX && smallObstacleY === appleY) ||
        smallObstacleArray.some(obstacle => obstacle[0] === smallObstacleX && obstacle[1] === smallObstacleY)
    ) {
        smallObstacle();
        return;
    }

    //push obstacles into the poopoo array
    smallObstacleArray.push([smallObstacleX, smallObstacleY]);
}

//level 2

function bigObstacle() {
    let bigObstacleX = Math.floor(Math.random() * tileAmount) * tileSize;
    let bigObstacleY = Math.floor(Math.random() * tileAmount) * tileSize;
    // if statement för att inte få problem
    if (
        bigObstacleX === 0 ||
        bigObstacleX === tileSize ||
        bigObstacleX === gridSize - tileSize ||
        bigObstacleY === 0 ||
        bigObstacleY === tileSize ||
        bigObstacleY === gridSize - tileSize 
    ){
        bigObstacle();
        return;
    }

    // Ensure the obstacle does not overlap with the snake's head, body, fruit, or other big obstacles
    if (
        // SNAKE HEAD
        (bigObstacleX === snakeX && bigObstacleY === snakeY) || // Center block
        (bigObstacleX + tileSize === snakeX && bigObstacleY === snakeY) || // Right block
        (bigObstacleX - tileSize === snakeX && bigObstacleY === snakeY) || // Left block
        (bigObstacleX === snakeX && bigObstacleY + tileSize === snakeY) || // Bottom block
        (bigObstacleX === snakeX && bigObstacleY - tileSize === snakeY) || // Top block
        // 2 tiles away from snake head ( 50px ) (positive x)(positive & negative y)
        (bigObstacleX + tileSize * 2 === snakeX && bigObstacleY === snakeY) || // 1 tile right  
        (bigObstacleX + tileSize * 3 === snakeX && bigObstacleY === snakeY) || // 2 tiles right
        (bigObstacleX === snakeX && bigObstacleY + tileSize * 2 === snakeY) || // 1 tile down
        (bigObstacleX === snakeX && bigObstacleY + tileSize * 3 === snakeY) || // 2 tiles down
        (bigObstacleX === snakeX && bigObstacleY - tileSize * 2 === snakeY) || // 1 tiles up
        (bigObstacleX === snakeX && bigObstacleY - tileSize * 3 === snakeY) || // 2 tiles up

        // SNAKE BODY
        snakeBody.some(segment =>
            (segment[0] === bigObstacleX && segment[1] === bigObstacleY) || // Center block
            (segment[0] === bigObstacleX + tileSize && segment[1] === bigObstacleY) || // Right block
            (segment[0] === bigObstacleX - tileSize && segment[1] === bigObstacleY) || // Left block
            (segment[0] === bigObstacleX && segment[1] === bigObstacleY + tileSize) || // Bottom block
            (segment[0] === bigObstacleX && segment[1] === bigObstacleY - tileSize) // Top block
        ) ||

        // FRUIT
        (bigObstacleX === appleX && bigObstacleY === appleY) || // Center block
        (bigObstacleX + tileSize === appleX && bigObstacleY === appleY) || // Right block
        (bigObstacleX - tileSize === appleX && bigObstacleY === appleY) || // Left block
        (bigObstacleX === appleX && bigObstacleY + tileSize === appleY) || // Bottom block
        (bigObstacleX === appleX && bigObstacleY - tileSize === appleY) || // Top block

        // ( Nödvändigt att inte kunna spawna med frukten i ett hörn eftersom den blir omöjlig att få om den hamnar med block på 3 olika sidor)
        (bigObstacleX + tileSize === appleX && bigObstacleY + tileSize === appleY) || // Bottom right block
        (bigObstacleX - tileSize === appleX && bigObstacleY + tileSize === appleY) || // Bottom left block
        (bigObstacleX + tileSize === appleX && bigObstacleY - tileSize === appleY) || // Top right block
        (bigObstacleX - tileSize === appleX && bigObstacleY - tileSize === appleY) || // Top left block


        // OTHER BIG OBSTACLES
        bigObstacleArray.some(obstacle =>
            (obstacle[0] === bigObstacleX && obstacle[1] === bigObstacleY) || // Center block
            (obstacle[0] === bigObstacleX + tileSize && obstacle[1] === bigObstacleY) || // Right block
            (obstacle[0] === bigObstacleX - tileSize && obstacle[1] === bigObstacleY) || // Left block
            (obstacle[0] === bigObstacleX && obstacle[1] === bigObstacleY + tileSize) || // Bottom block
            (obstacle[0] === bigObstacleX && obstacle[1] === bigObstacleY - tileSize) || // Top block 
            (obstacle[0] + tileSize === bigObstacleX && obstacle[1] + tileSize === bigObstacleY) || // Bottom right block
            (obstacle[0] - tileSize === bigObstacleX && obstacle[1] + tileSize === bigObstacleY) || // Bottom left block
            (obstacle[0] + tileSize === bigObstacleX && obstacle[1] - tileSize === bigObstacleY) || // Top right block
            (obstacle[0] - tileSize === bigObstacleX && obstacle[1] - tileSize === bigObstacleY) || // Top left block
            (obstacle[0] + tileSize * 2 === bigObstacleX && obstacle[1] === bigObstacleY) || // 1 tile right
            (obstacle[0] - tileSize * 2 === bigObstacleX && obstacle[1] === bigObstacleY) || // 1 tile left
            (obstacle[0] === bigObstacleX && obstacle[1] + tileSize * 2 === bigObstacleY) || // 1 tile down
            (obstacle[0] === bigObstacleX && obstacle[1] - tileSize * 2 === bigObstacleY) // 1 tile up
        )
    ) {
        bigObstacle(); // Try again if the obstacle overlaps with the snake, fruit, or other obstacles
        return; // Exit without adding the obstacle if it overlaps
    }

    // Push the obstacle to the array if all checks pass
    bigObstacleArray.push([bigObstacleX, bigObstacleY]);
}

// no level 3

//level 4
function generateFoods() {
    const foodCount = Math.floor(Math.random() * 5) + 1; // Random number of foods (1-5)
    foodArray = []; // Clear the array

    for (let i = 0; i < foodCount; i++) {
        let foodX, foodY;

        // Generate random positions and ensure no overlap with obstacles or snakes
        do {
            foodX = Math.floor(Math.random() * tileAmount) * tileSize;
            foodY = Math.floor(Math.random() * tileAmount) * tileSize;
        } while (
            (foodX === snakeX && foodY === snakeY) ||   // Overlaps with snake head
            foodArray.some(food => food[0] === foodX && food[1] === foodY) ||   // Overlaps with existing food
            snakeBody.some(segment => segment[0] === foodX && segment[1] === foodY)     // Overlaps with snake body
        );


        // Add the food position to the array
        foodArray.push([foodX, foodY]);
    }
}

//  normal mode
function normalMode() {
    clearInterval(gameInterval);
    gameInterval = setInterval(update, 1000 / 6);
    spawnSnake();
    placeFruit();

    points = 0;
    pointDiv.innerHTML = "Score:" + points;
    updateSpeed = 6;
    speedDiv.innerHTML = "Speed:" + Math.round(updateSpeed / 6 * 100) / 100;
}


// HIGHSCOORRREE BIUTCHHESSSS
high1 = localStorage.getItem("high1") ? parseInt(localStorage.getItem("high1")) : 0;
high2 = localStorage.getItem("high2") ? parseInt(localStorage.getItem("high2")) : 0;
high3 = localStorage.getItem("high3") ? parseInt(localStorage.getItem("high3")) : 0;
high4 = localStorage.getItem("high4") ? parseInt(localStorage.getItem("high4")) : 0;
high5 = localStorage.getItem("high5") ? parseInt(localStorage.getItem("high5")) : 0;

function updateHighscoreDisplay() {
    highscore1.innerHTML = "1. " + high1;
    highscore2.innerHTML = "2. " + high2;
    highscore3.innerHTML = "3. " + high3;
    highscore4.innerHTML = "4. " + high4;
    highscore5.innerHTML = "5. " + high5;
}
updateHighscoreDisplay();

function updateHighscores() {
    // Add the current score to the high scores list
    const scores = [high1, high2, high3, high4, high5, points];

    // Sort the scores in descending order and keep the top 5
    scores.sort((a, b) => b - a);
    [high1, high2, high3, high4, high5] = scores.slice(0, 5);

    // Save the updated high scores to localStorage
    localStorage.setItem("high1", high1);
    localStorage.setItem("high2", high2);
    localStorage.setItem("high3", high3);
    localStorage.setItem("high4", high4);
    localStorage.setItem("high5", high5);

    // Update the highscore display
    updateHighscoreDisplay();
}